﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        VM vm;
        public MainWindow()
        {
            InitializeComponent();
            vm = new VM();
            this.DataContext = vm;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            string selectedPerson = "Nobody";
            Person selected = vm.SelectedPerson;
            if (selected != null)
            {
                selectedPerson = selected.Name;
            }
            string msg = String.Format("{0} selected people,{1} is the selected person", vm.SelectedPeople.Count, selectedPerson);

            MessageBox.Show(msg);
        }
    }

    public class VM : INotifyPropertyChanged
    {
        private ObservableCollection<Person> people;
        private ObservableCollection<Person> selectedPeople;

        private Person _selectedPerson;
        public Person SelectedPerson
        {
            get { return _selectedPerson; }
            set
            {
                if (_selectedPerson != value)
                {
                    _selectedPerson = value;
                    this.RaisePropertyChanged("SelectedPerson");
                }
            }
        }

        public ObservableCollection<Person> People
        {
            get
            {
                return people;
            }
            set
            {
                people = value;
                this.RaisePropertyChanged("People");
            }
        }

        public ObservableCollection<Person> SelectedPeople
        {
            get
            {
                return selectedPeople;
            }
            set
            {
                selectedPeople = value;
                this.RaisePropertyChanged("People");
            }
        }
        
        public VM()
        {
            People = new ObservableCollection<Person>();
            SelectedPeople = new ObservableCollection<Person>();

            People.Add(new Person() { Age = 60, Name = "John" });
            People.Add(new Person() { Age = 12, Name = "Brenda" });
            People.Add(new Person() { Age = 10, Name = "Tom" });
            People.Add(new Person() { Age = 12, Name = "Fred" });
            
            SelectedPeople.Add(People[1]);
            SelectedPeople.Add(People[2]);
        }


        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private string name;
        private int age;

        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                if (this.name != value)
                {
                    this.name = value;
                    this.RaisePropertyChanged("Name");
                }
            }
        }

        public int Age
        {
            get
            {
                return this.age;
            }
            set
            {
                if (this.age != value)
                {
                    this.age = value;
                    this.RaisePropertyChanged("Age");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }


}
